
 
const nsICollection = Components.interfaces.nsICollection;
const nsIConsoleService = Components.interfaces.nsIConsoleService;
const nsISupportsCString = Components.interfaces.nsISupportsCString;
const nsISupportsString = Components.interfaces.nsISupportsString;
const nsIPrefService = Components.interfaces.nsIPrefService;
 
 
const WSPOPTION_CONTRACTID = '@scenari.com/ui/wspOption;1';
const WSPOPTION_CID = Components.ID('{56A6270C-0B0F-4845-91A2-83A73D508102}');
const WSPOPTION_IID = Components.interfaces.scIWspOptionUi;


function scWspOptionUi() {
	this.fUiDom = "";
}


scWspOptionUi.prototype = {
  /**
	* Initialisation
	*	@param <element wspPresUrl=""/>
	**/
	init : function(pUiDom) {
		try{
			this.fUiDom = pUiDom;
		}catch(e){
			debug("scWspOptionUi > init :: " + e);
		}
	},
  /**
	* Retourne le titre
	* 	@title
	**/
	getTitle : function() {
		try{
			if(this.fUiDom){
				return this.fUiDom.hasAttribute("title") ? this.fUiDom.getAttribute("title") : this.fUiDom.getAttribute("uri");
			}
			return null;
		}catch(e){
			debug("scWspOptionUi > getTitle :: " + e);
			return null;
		}
	},
  /**
	* Retourne l'URL d'une page XUL correspondant  une prsentation de l'atelier
	* 	@wspPresUrl
	**/
	getWspPresUrl : function() {
		try{
			if(this.fUiDom && this.fUiDom.hasAttribute("wspPresUrl")){
				return this.fUiDom.getAttribute("wspPresUrl");
			}
			return null;
		}catch(e){
			debug("scWspOptionUi > getWspPresUrl :: " + e);
			return null;
		}
	},
	QueryInterface: function(pIId) {
        if (!pIId.equals(nsISupports) &&
            !pIId.equals(WSPOPTION_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
}


function debug(pText){
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}
function listProperties (pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}



var scWspOptionUiModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(WSPOPTION_CID, 
                                        "scWspOptionUi JS component", 
                                        WSPOPTION_CONTRACTID, 
                                        fileSpec, 
                                        location,
                                        type);
                            	
    },

    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(WSPOPTION_CID)) throw Components.results.NS_ERROR_NO_INTERFACE;
        if (!iid.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        return scWspOptionUiFactory;
    },
    unregisterSelf : function mod_unreg(compMgr, location, type) {
  
  	},
    canUnload: function(compMgr) { return true; }
};


var scWspOptionUiFactory = {
    createInstance: function(outer, iid) {
    	try{
	        if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
	        if (!iid.equals(WSPOPTION_IID) && !iid.equals(Components.interfaces.nsISupports))
	            throw Components.results.NS_ERROR_INVALID_ARG;
	      }catch(e){
	      	debug("scWspOptionFactory > createInstance :: " + e);
	      }finally{
	      	return new scWspOptionUi();
	      }
    }
}


function NSGetModule(comMgr, fileSpec) { return scWspOptionUiModule; }

